The wl_data_device interface

## Data Structures

struct | wl_data_device_listener

## Macros

#define | WL_DATA_DEVICE_DATA_OFFER_SINCE_VERSION 1
#define | WL_DATA_DEVICE_ENTER_SINCE_VERSION 1
#define | WL_DATA_DEVICE_LEAVE_SINCE_VERSION 1
#define | WL_DATA_DEVICE_MOTION_SINCE_VERSION 1
#define | WL_DATA_DEVICE_DROP_SINCE_VERSION 1
#define | WL_DATA_DEVICE_SELECTION_SINCE_VERSION 1
#define | WL_DATA_DEVICE_START_DRAG_SINCE_VERSION 1
#define | WL_DATA_DEVICE_SET_SELECTION_SINCE_VERSION 1
#define | WL_DATA_DEVICE_RELEASE_SINCE_VERSION 2

## Functions

static int | wl_data_device_add_listener (struct wl_data_device *wl_data_device, const struct wl_data_device_listener *listener, void *data)
static void | wl_data_device_set_user_data (struct wl_data_device *wl_data_device, void *user_data)
static void * | wl_data_device_get_user_data (struct wl_data_device *wl_data_device)
static void | wl_data_device_destroy (struct wl_data_device *wl_data_device)
static void | wl_data_device_start_drag (struct wl_data_device *wl_data_device, struct wl_data_source *source, struct wl_surface *origin, struct wl_surface *icon, uint32_t serial)
static void | wl_data_device_set_selection (struct wl_data_device *wl_data_device, struct wl_data_source *source, uint32_t serial)
static void | wl_data_device_release (struct wl_data_device *wl_data_device)

## Detailed Description

There is one wl_data_device per seat which can be obtained from the global wl_data_device_manager singleton.

A wl_data_device provides access to inter-client data transfer mechanisms such as copy-and-paste and drag-and-drop.

## Macro Definition Documentation

## WL_DATA_DEVICE_DATA_OFFER_SINCE_VERSION

#define WL_DATA_DEVICE_DATA_OFFER_SINCE_VERSION 1

Definition at line 2455 of file wayland-client-protocol.h.

## WL_DATA_DEVICE_DROP_SINCE_VERSION

#define WL_DATA_DEVICE_DROP_SINCE_VERSION 1

Definition at line 2471 of file wayland-client-protocol.h.

## WL_DATA_DEVICE_ENTER_SINCE_VERSION

#define WL_DATA_DEVICE_ENTER_SINCE_VERSION 1

Definition at line 2459 of file wayland-client-protocol.h.

## WL_DATA_DEVICE_LEAVE_SINCE_VERSION

#define WL_DATA_DEVICE_LEAVE_SINCE_VERSION 1

Definition at line 2463 of file wayland-client-protocol.h.

## WL_DATA_DEVICE_MOTION_SINCE_VERSION

#define WL_DATA_DEVICE_MOTION_SINCE_VERSION 1

Definition at line 2467 of file wayland-client-protocol.h.

## WL_DATA_DEVICE_RELEASE_SINCE_VERSION

#define WL_DATA_DEVICE_RELEASE_SINCE_VERSION 2

Definition at line 2488 of file wayland-client-protocol.h.

## WL_DATA_DEVICE_SELECTION_SINCE_VERSION

#define WL_DATA_DEVICE_SELECTION_SINCE_VERSION 1

Definition at line 2475 of file wayland-client-protocol.h.

## WL_DATA_DEVICE_SET_SELECTION_SINCE_VERSION

#define WL_DATA_DEVICE_SET_SELECTION_SINCE_VERSION 1

Definition at line 2484 of file wayland-client-protocol.h.

## WL_DATA_DEVICE_START_DRAG_SINCE_VERSION

#define WL_DATA_DEVICE_START_DRAG_SINCE_VERSION 1

Definition at line 2480 of file wayland-client-protocol.h.

## Function Documentation

## wl_data_device_add_listener()

static int wl_data_device_add_listener | ( | struct wl_data_device * | wl_data_device,
|  | const struct wl_data_device_listener * | listener,
|  | void * | data
| ) |  |

inline static

Definition at line 2441 of file wayland-client-protocol.h.

{
return wl_proxy_add_listener((struct wl_proxy *) wl_data_device,
(void (**)(void)) listener, data);
}
data
GLint GLenum GLsizei GLsizei GLsizei GLint GLsizei const GLvoid * data
Definition: SDL_opengl.h:1974

## wl_data_device_destroy()

static void wl_data_device_destroy | ( | struct wl_data_device * | wl_data_device | ) |

inline static

Definition at line 2512 of file wayland-client-protocol.h.

{
wl_proxy_destroy((struct wl_proxy *) wl_data_device);
}

## wl_data_device_get_user_data()

static void* wl_data_device_get_user_data | ( | struct wl_data_device * | wl_data_device | ) |

inline static

Definition at line 2499 of file wayland-client-protocol.h.

{
return wl_proxy_get_user_data((struct wl_proxy *) wl_data_device);
}

## wl_data_device_release()

static void wl_data_device_release | ( | struct wl_data_device * | wl_data_device | ) |

inline static

This request destroys the data device.

Definition at line 2576 of file wayland-client-protocol.h.

References WL_DATA_DEVICE_RELEASE.

{
wl_proxy_marshal((struct wl_proxy *) wl_data_device,
WL_DATA_DEVICE_RELEASE);
wl_proxy_destroy((struct wl_proxy *) wl_data_device);
}
WL_DATA_DEVICE_RELEASE
#define WL_DATA_DEVICE_RELEASE
Definition: wayland-client-protocol.h:2450

## wl_data_device_set_selection()

static void wl_data_device_set_selection | ( | struct wl_data_device * | wl_data_device,
|  | struct wl_data_source * | source,
|  | uint32_t | serial
| ) |  |

inline static

This request asks the compositor to set the selection to the data from the source on behalf of the client.

To unset the selection, set the source to NULL.

Definition at line 2564 of file wayland-client-protocol.h.

References WL_DATA_DEVICE_SET_SELECTION.

{
wl_proxy_marshal((struct wl_proxy *) wl_data_device,
WL_DATA_DEVICE_SET_SELECTION, source, serial);
}
WL_DATA_DEVICE_SET_SELECTION
#define WL_DATA_DEVICE_SET_SELECTION
Definition: wayland-client-protocol.h:2449
source
GLsizei GLsizei GLchar * source
Definition: SDL_opengl_glext.h:677

## wl_data_device_set_user_data()

static void wl_data_device_set_user_data | ( | struct wl_data_device * | wl_data_device,
|  | void * | user_data
| ) |  |

inline static

Definition at line 2492 of file wayland-client-protocol.h.

{
wl_proxy_set_user_data((struct wl_proxy *) wl_data_device, user_data);
}

## wl_data_device_start_drag()

static void wl_data_device_start_drag | ( | struct wl_data_device * | wl_data_device,
|  | struct wl_data_source * | source,
|  | struct wl_surface * | origin,
|  | struct wl_surface * | icon,
|  | uint32_t | serial
| ) |  |

inline static

This request asks the compositor to start a drag-and-drop operation on behalf of the client.

The source argument is the data source that provides the data for the eventual data transfer. If source is NULL, enter, leave and motion events are sent only to the client that initiated the drag and the client is expected to handle the data passing internally.

The origin surface is the surface where the drag originates and the client must have an active implicit grab that matches the serial.

The icon surface is an optional (can be NULL) surface that provides an icon to be moved around with the cursor. Initially, the top-left corner of the icon surface is placed at the cursor hotspot, but subsequent wl_surface.attach request can move the relative position. Attach requests must be confirmed with wl_surface.commit as usual. The icon surface is given the role of a drag-and-drop icon. If the icon surface already has another role, it raises a protocol error.

The current and pending input regions of the icon wl_surface are cleared, and wl_surface.set_input_region is ignored until the wl_surface is no longer used as the icon surface. When the use as an icon ends, the current and pending input regions become undefined, and the wl_surface is unmapped.

Definition at line 2549 of file wayland-client-protocol.h.

References WL_DATA_DEVICE_START_DRAG.

{
wl_proxy_marshal((struct wl_proxy *) wl_data_device,
WL_DATA_DEVICE_START_DRAG, source, origin, icon, serial);
}
WL_DATA_DEVICE_START_DRAG
#define WL_DATA_DEVICE_START_DRAG
Definition: wayland-client-protocol.h:2448
source
GLsizei GLsizei GLchar * source
Definition: SDL_opengl_glext.h:677